<template>
  <q-chip
    clickable
    :label="labelChip"
    :color="colorChip && 'primary' || 'red'"
    :outline="outlineChip"
    :text-color="textColorChip"
    :disable="!isAuth"
    :class="{'pointer-events-none':!isAuth}"
  >
    <q-menu anchor="center middle"
            self="center middle"
            max-height="250px"
            class="p-2"
    >
      <q-select
        v-model="modelSelect"
        :model-value="tempLabel"
        dense
        row-key="username"
        option-label="username"
        :options="options"
        @filter="filterUsers"
        map-options
        use-input
      >
        <template v-slot:option="{ itemProps, opt, selected, toggleOption }">
          <q-item :class="{'pointer-events-none opacity-30 text-pink':opt.block}" v-bind="itemProps">
            <q-item-section @click="selectUser({username: opt.username, _id: opt._id})" >
              <q-item-label v-close-popup v-html="opt.username" />
              <q-item-label class="opacity-60 text-sm" v-close-popup v-html="useTranslitRoles(opt.roles[0])" />
            </q-item-section>
            <q-badge v-if="opt.online && opt.online.status" rounded color="blue" class="absolute right-0.5"/>
          </q-item>
        </template>
        <template v-slot:no-option>
          <q-item>
            <q-item-section class="text-grey">
              Нет результатов
            </q-item-section>
          </q-item>
        </template>
      </q-select>
    </q-menu>
  </q-chip>
</template>

<script>
import {computed, ref} from "vue";
import api from "../API/api";
import {useUpdateLead} from "./useUpdateLead";
import {useRoute} from "vue-router";
import useTranslitRoles from "./useTranslitRoles";
import {useStore} from "vuex";

let stringOptions = [].reduce((acc, opt) => {
  for (let i = 1; i <= 5; i++) {
    acc.push(opt + ' ' + i)
  }
  return acc
}, [])

export default {
  name: "UserSelected",
  props: {
    labelChip: {type: String, required: false},
    colorChip: {type: String, required: false},
    outlineChip: {type: Boolean, required: false},
    textColorChip: {type: String, required: false},
    optionLabelSelect: {type: String, required: false},
    modelSelect: {required: true},
    modelValue: {type: String, required: true},
    labelSelect: {required: false},
  },
  setup (props, {emit}) {

    const route = useRoute();
    const users = ref([])
    const options = ref([])
    const store = useStore()
    const isAuth = store.getters.isAuth
    const tempLabel = ref(props.labelChip)

    async function getUsers () {
      users.value = []
      options.value = []
      await api.getUsers()
          .then(res => {
            users.value = [...res.data.users]
          })
    }

    async function selectUser (user) {
      tempLabel.value = user.username
      emit('selectUser', user)
    }

    async function filterUsers (val, update, abort) {
      tempLabel.value = ''
      options.value = [];
      stringOptions = [];

// Функция для объединения уникальных элементов в массиве без дубликатов
      function mergeUnique(arr, newArr) {
        newArr.forEach(newObj => {
          // Проверяем, есть ли объект с таким же _id уже в массиве
          if (!arr.some(obj => obj._id === newObj._id)) {
            arr.push(newObj); // Если нет, добавляем его
          }
        });
      }

// Запрос getUsers
      if (options.value.length === 0) {
        await api.getUsers().then(res => {
          console.log(store.state.user)
          const myArr = res.data.users.map(obj => {
            const { username, _id, online, roles, block } = obj;
            return { username, _id, online, roles, block };
          });
          mergeUnique(stringOptions, myArr); // Объединяем уникальные элементы
        });
      }

// Запрос getAdmins
      if (route.name === 'Lead') {
        await api.getAdmins().then(res => {
          const myArr = res.data.users.map(obj => {
            const { username, _id, online, roles } = obj;
            return { username, _id, online, roles };
          });
          options.value = []; // Сбрасываем options.value перед добавлением новых элементов
          mergeUnique(stringOptions, myArr); // Объединяем уникальные элементы
        });
      }
      update(() => {
        const needle = val.toLocaleLowerCase()
        options.value = stringOptions.filter(v => v.username.toLocaleLowerCase().indexOf(needle) > -1)
      })
    }

    return {
      users,
      options,
      isAuth,
      getUsers,
      selectUser,
      filterUsers,
      useTranslitRoles,
      tempLabel,
      // useUpdateLead,
    }

  }
}
</script>

<style scoped>

</style>
